#include<conio.h>
#include<dos.h>
#include<time.h>
#include<stdlib.h>
#include<string.h>
#include<stdio.h>

struct ts_os_ver {int maj; int min; };

#define DOS     0
#define OS2     1
#define DV      2
#define WINS    3
#define WIN3    4
			/*   76543210  */
#define is_DOS  0x01    /* b'00000001' */
#define is_OS2  0x02    /* b'00000010' */
#define is_DV   0x04    /* b'00000100' */
#define is_WINS 0x08    /* b'00001000' */
#define is_WIN3 0x10    /* b'00010000' */

struct ts_os_ver t_os_ver[5];
int t_os_type;
int t_os;
char t_os_name[41];

void t_slice(void);
int get_os(void);

main(int argc, char *argv[])
{
    time_t start,now;
    unsigned int sec_pause;
    char *str;

    puts("\nPauseIT v0.2 - Public Domain by Damien Guard 1996 - Envy Technologies");

    if (argc != 2) {
	puts("Usage: PAUSEIT delay\n\r       delay = time to wait in seconds");
	exit (1);
       }

    get_os();

    while (kbhit()) getch();
    start = time(NULL);
    now = start;
    str = argv[1];

    sec_pause = atoi(str);

    printf("  Pausing for %d seconds under %s v%d.%d\n",sec_pause,t_os_name,t_os_ver[t_os].maj,t_os_ver[t_os].min);

    while(difftime(now,start) < (double) sec_pause && !kbhit()) {
	now=time(NULL);
	t_slice();
       };
    return(0);
}
int get_os (void)
{
      union REGS t_regs;

      t_os_type = 0;
      t_os = 0;

      /* test for DOS or OS/2 */
      if (_osmajor < 10) {
	    t_os_ver[DOS].maj = _osmajor;
	    t_os_ver[DOS].min = _osminor;
	    t_os_type = t_os_type | is_DOS;
	    strcpy(t_os_name,"DOS");
      } else {
	    t_os_type = t_os_type | is_OS2;
	    t_os_ver[OS2].maj = _osmajor/10;
	    t_os_ver[OS2].min = _osminor;
	    if (t_os_ver[OS2].maj == 3 ) {
	       strcpy(t_os_name,"OS/2 Warp");
	      } else {
	       strcpy(t_os_name,"OS/2");
	      };
      };

      /* test for Windows */
      t_regs.x.ax = 0x4680;
      int86(0x2F, &t_regs, &t_regs);

      if (t_regs.x.ax == 0x0000) {
	    t_os_ver[WINS].maj = 3;
	    t_os_ver[WINS].min = 0;
	    t_os_type = t_os_type | is_WINS;
      } else {
	    t_regs.x.ax = 0x1600 ;
	    int86(0x2F, &t_regs, &t_regs);
	    switch (t_regs.h.al) {
	      case 0x00 :
	      case 0x80 :
	      case 0x01 :
	      case 0xFF :
		  break;
	      default   :
		  t_os_type = t_os_type | is_WIN3;
		  t_os_ver[WIN3].maj = t_regs.h.al;
		  t_os_ver[WIN3].min = t_regs.h.ah;
		  if (t_os_ver[WIN3].maj == 4) {
		     strcpy(t_os_name,"Windows 95");
		     t_os_ver[WIN3].maj = t_os_ver[WIN3].maj - 3;
		    } else {
		     strcpy(t_os_name,"Windows");
		    }; break;
	    };
      };

      /* Test for DESQview */
      t_regs.x.cx = 0x4445;     /* load incorrect date */
      t_regs.x.dx = 0x5351;
      t_regs.x.ax = 0x2B01;     /*  DV set up call     */

      intdos(&t_regs, &t_regs);
      if (t_regs.h.al != 0xFF) {
	    t_os_type = t_os_type | is_DV;
	    t_os_ver[DV].maj = t_regs.h.bh;
	    t_os_ver[DV].min = t_regs.h.bl;
	    strcpy(t_os_name,"DESQview");
	};

      if(t_os_type & is_DOS)  t_os = DOS;
      if(t_os_type & is_DV)   t_os = DV;
      if(t_os_type & is_WINS) t_os = WINS;
      if(t_os_type & is_WIN3) t_os = WIN3;
      if(t_os_type & is_OS2)  t_os = OS2;
      return(t_os-1);
}
//---------------------------------------------------------------------------
void t_slice(void)
{
      union REGS t_regs;
      switch (t_os) {
	case DOS  : break;
	case OS2  :
	case WIN3 :
	case WINS :
	    t_regs.x.ax = 0x1680;
	    int86(0x2f,&t_regs,&t_regs);
	    break;
	case DV   :
	    t_regs.x.ax = 0x1000;
	    int86(0x15,&t_regs,&t_regs);
	    break;
      };
}